<?php

namespace ShineSoftware\Constriv\Controller\Main;

use Magento\Framework\App\Action\Context;
use Magento\Quote\Model\QuoteFactory;
use Magento\Sales\Model\OrderFactory;
use Psr\Log\LoggerInterface;

class Error extends AbstractMain {

    /**
     * @var OrderFactory
     */
    protected $_modelOrderFactory;


    public function __construct(Context $context, QuoteFactory $modelQuoteFactory, LoggerInterface $logLoggerInterface, OrderFactory $modelOrderFactory) {
        $this->_modelOrderFactory = $modelOrderFactory;

        parent::__construct($context, $modelQuoteFactory, $logLoggerInterface);
    }

    public function execute() {
        $session = $this->getCheckout();
        $order = $this->_modelOrderFactory->create();
        $order->loadByIncrementId($session->getLastRealOrderId());
        $order->cancel();
        $order->save();
        $this->_logLoggerInterface->debug(__METHOD__ . " (" . __LINE__ . ") - Redirect the user at the magento failure page!", null, 'shinesoftware_constriv.log');
        Mage::app()->getFrontController()->getResponse()->setRedirect($this->_url->getBaseUrl() . 'checkout/onepage/failure');
    }

}
