<?php

namespace ShineSoftware\Constriv\Controller\Moto;

use Magento\Framework\App\Action\Context;
use Magento\Framework\App\ObjectManager;
use Magento\Framework\View\LayoutFactory;
use Magento\Quote\Model\QuoteFactory;
use Magento\Sales\Model\OrderFactory;
use Psr\Log\LoggerInterface;

class Enrolled extends AbstractMoto {

    /**
     * @var OrderFactory
     */
    protected $_modelOrderFactory;

    /**
     * @var LayoutFactory
     */
    protected $_viewLayoutFactory;

    public function __construct(Context $context, QuoteFactory $modelQuoteFactory, LoggerInterface $logLoggerInterface, OrderFactory $modelOrderFactory, LayoutFactory $viewLayoutFactory) {
        $this->_modelOrderFactory = $modelOrderFactory;
        $this->_viewLayoutFactory = $viewLayoutFactory;

        parent::__construct($context, $modelQuoteFactory, $logLoggerInterface);
    }

    public function execute() {
        $order = $this->_modelOrderFactory->create();
        $order->loadByIncrementId(ObjectManager::getInstance()->get('Magento\Checkout\Model\Session')->getLastRealOrderId());
        $this->loadLayout();
        $block = $this->_viewLayoutFactory->create()->createBlock('ShineSoftware\Constriv\Block\Moto\Enrolled', 'constriv', ['template' => 'constriv/moto/enrolled.phtml']);
        $block->setData('order', $order);
        $this->_viewLayoutFactory->create()->getBlock('content')->append($block);
        $this->renderLayout();
    }

}
