<?php

namespace ShineSoftware\Constriv\Controller\Moto;

use Magento\Framework\App\Action\Context;
use Magento\Quote\Model\QuoteFactory;
use Magento\Sales\Model\OrderFactory;
use Psr\Log\LoggerInterface;
use ShineSoftware\Constriv\Model\Gateway;
use ShineSoftware\Constriv\Model\Gateways\Moto;

class Enrolledback extends AbstractMoto {

    /**
     * @var Gateway
     */
    protected $_modelGateway;

    /**
     * @var Moto
     */
    protected $_gatewaysMoto;

    /**
     * @var OrderFactory
     */
    protected $_modelOrderFactory;

    public function __construct(Context $context, QuoteFactory $modelQuoteFactory, LoggerInterface $logLoggerInterface, Gateway $modelGateway, Moto $gatewaysMoto, OrderFactory $modelOrderFactory) {
        $this->_modelGateway = $modelGateway;
        $this->_gatewaysMoto = $gatewaysMoto;
        $this->_modelOrderFactory = $modelOrderFactory;

        parent::__construct($context, $modelQuoteFactory, $logLoggerInterface);
    }

    public function execute() {
        $gateway = $this->_modelGateway;
        $moto = $this->_gatewaysMoto;
        $order = $this->_modelOrderFactory->create();
        $orderId = $this->getRequest()->getParam('MD');
        $PaRes = $this->getRequest()->getParam('PaRes');
        if ($moto->requestPatTransaction($orderId, $PaRes)) {
            $order->loadByIncrementId($orderId);
            $gateway->completeOrder($order);
            $this->successAction();
        }
    }

}
